param.h File Reference
`#include <c++-gtk-utils/cgu_config.h>`

Go to the source code of this file.

## Classes

class | Cgu::Param< T >
| Struct for automatic typing of function parameter arguments. More...
struct | Cgu::Param< T & >
struct | Cgu::Param< T * >
class | Cgu::RemoveRefCond< T, unref >
| Struct which will conditionally convert a reference type to a value type. More...
struct | Cgu::RemoveRefCond< T, true >
struct | Cgu::RemoveRefCond< T &, true >
struct | Cgu::RemoveRefCond< T, false >
struct | Cgu::RemoveRefCond< T &, false >

## Namespaces

| Cgu

## Functions

template<class Func , class... TupleArgs, class... OtherArgs>
auto | Cgu::tuple_apply (Func &&func, const std::tuple< TupleArgs... > &t, OtherArgs &&... args) -> typename std::result_of< Func(const TupleArgs &..., OtherArgs &&...)>::type
template<class Func , class... TupleArgs, class... OtherArgs>
auto | Cgu::tuple_apply (Func &&func, std::tuple< TupleArgs... > &t, OtherArgs &&... args) -> typename std::result_of< Func(TupleArgs &..., OtherArgs &&...)>::type
template<class Func , class... TupleArgs, class... OtherArgs>
auto | Cgu::tuple_apply (Func &&func, std::tuple< TupleArgs... > &&t, OtherArgs &&... args) -> typename std::result_of< Func(TupleArgs &&..., OtherArgs &&...)>::type
template<class Obj , class Ret , class... FuncArgs, class Tuple , class... OtherArgs>
Ret | Cgu::tuple_apply (Obj &obj, Ret(Obj::*func)(FuncArgs...), Tuple &&t, OtherArgs &&... args)
template<class Obj , class Ret , class... FuncArgs, class Tuple , class... OtherArgs>
Ret | Cgu::tuple_apply (const Obj &obj, Ret(Obj::*func)(FuncArgs...) const, Tuple &&t, OtherArgs &&... args)